# coding: utf-8

"""
    ibl-data-manager

    API for iblai

    The version of the OpenAPI document: 3.54.3-ai-plus
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from iblai.models.access_enum import AccessEnum
from typing import Optional, Set
from typing_extensions import Self

class RetrieverDocumentEmbeddingRequest(BaseModel):
    """
    RetrieverDocumentEmbeddingRequest
    """ # noqa: E501
    document_name: Optional[StrictStr] = Field(default=None, description="The name of the document")
    document_type: Optional[StrictStr] = Field(default=None, description="The type of the document")
    pathway: StrictStr = Field(description="The pathway to retrain the document in")
    url: Optional[StrictStr] = Field(default=None, description="The url of the document")
    train: Optional[StrictBool] = Field(default=None, description="The type of the document")
    access: Optional[AccessEnum] = Field(default=None, description="The access of the document.  * `public` - Public * `private` - Private")
    __properties: ClassVar[List[str]] = ["document_name", "document_type", "pathway", "url", "train", "access"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RetrieverDocumentEmbeddingRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RetrieverDocumentEmbeddingRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "document_name": obj.get("document_name"),
            "document_type": obj.get("document_type"),
            "pathway": obj.get("pathway"),
            "url": obj.get("url"),
            "train": obj.get("train"),
            "access": obj.get("access")
        })
        return _obj


